package core

import (
	"git.urbach.dev/cli/q/src/expression"
)

// FoldLeaf tries to fold a leaf expression.
func (f *Function) FoldLeaf(expr *expression.Expression) error {
	if !expr.Token.IsNumeric() {
		return nil
	}

	value, err := f.ToNumber(expr.Token)
	expr.Value = value
	expr.IsFolded = true
	return err
}
