package eval

import (
	"git.urbach.dev/cli/q/src/asm"
	"git.urbach.dev/cli/q/src/types"
)

// Memory is a region in memory that can be addressed by an instruction.
type Memory struct {
	Typ    types.Type
	Memory asm.Memory
}

func (v *Memory) String() string {
	return "Memory"
}

func (v *Memory) Type() types.Type {
	return v.Typ
}
